/******************************************************************************
*
* project name:    SOKOMIZE
* initial date:    30/05/2000
* author:          thomas.nussbaumer@gmx.net
* description:     menu data and handling routines
*
* Title picture converted and RLE compressed using
* Image Studio v1.1     by Matt Johnson
*
* -----------------------------------------------------------------------------
* Revision History
* -----------------------------------------------------------------------------
*
* v1.00: 30/05/2000
*        initial version
*
******************************************************************************/

/*===========================================================================*/
/* RLE decompression routine                                                 */
/*                                                                           */
/* dest      ... pointer to destination where store decompressed data        */
/* source    ... pointer to RLE compressed data                              */
/* size      ... size of decompressed data                                   */
/* drawbytes ... number of bytes to draw per line                            */
/* offset    ... number of bytes to skip after each line                     */
/*                                                                           */
/*===========================================================================*/
void Decompress(unsigned char* dest,
                unsigned char* source,
                unsigned short size,
                unsigned char  drawbytes,
                unsigned char  offset)
{
    unsigned char len,val,counter = 0;

    while (size) {
        if (*source == 0x91) {
            source++;
            val = *source++;
            len = *source++;
            while (len) {
                *dest++ = val;
                len--;
                size--;
                counter++;
                if (counter == drawbytes) {
                    dest+=offset;
                    counter=0;
                }
            }
        }
        else {
           *dest++ = *source++;
           size--;
           counter++;
           if (counter == drawbytes) {
               dest+=offset;
               counter=0;
           }
        }
    }
}


unsigned char menu_data1[] = {
0x91,0x00,0x28,0x21,0x00,0x21,0x00,0x21,0x00,0x21,0x00,0x21,0x00,0x21,0x00,0x21,0x00,0x21,0x00,0x21,
0x00,0x21,0x00,0x1F,0x91,0xFF,0x12,0xFE,0x1F,0x91,0xFF,0x12,0xFC,0x1F,0x91,0xFF,0x12,0xF8,0x1C,0x80,
0x00,0x80,0x00,0x80,0x00,0x80,0x00,0x80,0x00,0x80,0x00,0x80,0x00,0x80,0x00,0x80,0x00,0xB8,0x1D,0x00,
0x01,0x00,0x01,0x00,0x01,0x00,0x01,0x00,0x01,0x00,0x01,0x00,0x01,0x00,0x01,0x00,0x01,0x38,0x5C,0xE7,
0xC0,0x06,0x40,0x04,0x43,0xE5,0xC6,0x6F,0xC7,0x1C,0x70,0x07,0xCF,0x9F,0x7C,0xFF,0xF0,0x3C,0x9C,0xE3,
0x80,0x86,0x80,0x80,0x83,0xB1,0xC6,0xEC,0xCD,0x9C,0xF0,0x86,0xEC,0xD8,0xE6,0xC0,0xC0,0xB8,0x1E,0xF7,
0x9E,0x3E,0x7A,0x00,0x03,0x33,0x67,0x6C,0xDA,0xDE,0xF2,0x06,0x6E,0xD8,0x62,0xC0,0xC2,0x38,0x1C,0xF7,
0xBF,0x66,0xCC,0x00,0x0F,0x33,0x6F,0x6C,0xDC,0xDE,0xFC,0x06,0x6C,0xDF,0x7C,0xF8,0xCC,0x38,0x1C,0xD5,
0xB3,0x66,0xFC,0x00,0x03,0xE3,0x66,0xEC,0xD8,0xDA,0xB0,0x07,0xCF,0x98,0x1E,0xC0,0xC0,0x38,0x1C,0xDD,
0xB3,0x76,0xC0,0x10,0x03,0x77,0xF6,0xFC,0xD8,0xDB,0xB0,0x16,0x0D,0x98,0x06,0xD0,0xC0,0x38,0x1C,0xFD,
0xB7,0x76,0xCC,0x30,0x07,0x36,0x36,0x7C,0xCD,0xBB,0xB4,0x36,0x0C,0xF8,0x66,0xF0,0xC4,0x38,0x1C,0xE9,
0x9E,0x7E,0x78,0x60,0x0B,0x7E,0x3E,0x6F,0x8F,0x79,0x38,0x66,0x0C,0x7F,0x3C,0xF8,0xC8,0x78,0x1C,0x91,
0x00,0x12,0x38,0x1C,0x91,0x00,0x12,0x38,0x3D,0x00,0x21,0x00,0x21,0x00,0x21,0x00,0x21,0x00,0x21,0x00,
0x21,0x00,0x21,0x00,0x21,0x00,0x21,0x38,0x1E,0x06,0x02,0x06,0x02,0x06,0x02,0x06,0x02,0x06,0x02,0x06,
0x02,0x06,0x02,0x06,0x02,0x06,0x02,0x3E,0x1C,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x0C,
0x00,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x3C,0x1C,0x91,0x00,0x12,0x38,0x1C,0x80,0x00,0x80,0x00,0x80,0x00,
0x80,0x00,0x80,0x00,0x80,0x00,0x80,0x00,0x80,0x00,0x80,0x00,0xB8,0x1D,0x00,0x01,0x00,0x01,0x00,0x01,
0x00,0x01,0x00,0x01,0x00,0x01,0x00,0x01,0x00,0x01,0x00,0x01,0x38,0x5C,0x04,0x40,0x04,0x40,0x04,0x40,
0x04,0x40,0x04,0x40,0x04,0x40,0x04,0x40,0x04,0x40,0x04,0x40,0x3C,0x9C,0x91,0x80,0x12,0xB8,0x1E,0x00,
0x02,0x00,0x02,0x00,0x02,0x00,0x02,0x00,0x02,0x00,0x02,0x00,0x02,0x00,0x02,0x00,0x02,0x38,0x1C,0x00,
0x0C,0x00,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x0C,0x38,0x1C,0x91,
0x00,0x12,0x38,0x1C,0x10,0x00,0x10,0x00,0x10,0x00,0x10,0x00,0x10,0x00,0x10,0x00,0x10,0x00,0x10,0x00,
0x10,0x00,0x38,0x1C,0xF0,0x04,0x30,0x1D,0xF6,0x04,0x30,0x04,0x30,0x04,0x30,0x04,0x30,0x04,0x30,0x04,
0x30,0x04,0x38,0x1C,0xE0,0x00,0x00,0x1B,0x66,0x08,0x60,0x08,0x60,0x00,0x00,0x08,0x60,0x08,0x60,0x08,
0x60,0x00,0x38,0x1C,0xC0,0xF3,0x67,0x9F,0xB6,0x78,0x91,0x00,0x0C,0x38,0x1C,0xC1,0xBB,0x6C,0xDB,0x36,
0xCC,0x91,0x00,0x03,0x21,0x91,0x00,0x07,0x21,0x38,0x3D,0xC1,0xFB,0x6F,0xFB,0x36,0xFD,0x00,0x21,0x00,
0x02,0x06,0x21,0x00,0x21,0x00,0x21,0x00,0x02,0x3E,0x1E,0xC7,0x83,0x6C,0x1B,0x36,0xC2,0x06,0x02,0x06,
0x00,0x0C,0x02,0x06,0x02,0x06,0x02,0x06,0x00,0x3C,0x1C,0xCD,0x99,0xCC,0xDB,0x3E,0xCC,0x0C,0x00,0x0C,
0x91,0x00,0x03,0x0C,0x00,0x0C,0x00,0x0C,0x00,0x38,0x1C,0xFC,0xF1,0xC7,0x9B,0x36,0x78,0x91,0x00,0x04,
0x80,0x91,0x00,0x07,0xB8,0x1C,0x80,0x01,0x00,0x00,0x80,0x00,0x80,0x00,0x80,0x01,0x00,0x00,0x80,0x00,
0x80,0x00,0x80,0x01,0x38,0x1D,0x00,0x40,0x04,0x01,0x00,0x01,0x00,0x01,0x00,0x40,0x04,0x01,0x00,0x01,
0x00,0x01,0x00,0x40,0x3C,0x5C,0x04,0x80,0x80,0x40,0x04,0x40,0x04,0x40,0x04,0x80,0x80,0x40,0x04,0x40,
0x04,0x40,0x04,0x80,0xB8,0x9C,0xC0,0x02,0x00,0x98,0x80,0x80,0x81,0x80,0x80,0x02,0x00,0x91,0x80,0x06,
0x02,0x38,0x1E,0xC0,0x0C,0x00,0x1A,0x00,0x02,0x01,0x82,0x00,0x0C,0x00,0x02,0x00,0x02,0x00,0x02,0x00,
0x0C,0x38,0x1C,0xC0,0xF3,0x67,0x9F,0xE6,0x6F,0xF9,0xFD,0xE7,0x80,0x00,0x0C,0x00,0x0C,0x00,0x0C,0x00,
0x00,0x38,0x1C,0xC1,0x9B,0x7C,0xDB,0x36,0x6C,0xCD,0x9B,0x36,0x00,0x10,0x91,0x00,0x07,0x38,0x1C,0xD1,
0xFF,0x7F,0xDB,0x36,0x6C,0xDD,0x9B,0xF6,0x04,0x30,0x00,0x10,0x00,0x10,0x00,0x10,0x04,0x38,0x1C,0xF1,
0x8B,0x6C,0x1F,0x36,0x6C,0xFD,0x9F,0x36,0x08,0x60,0x04,0x30,0x04,0x30,0x04,0x30,0x08,0x78,0x1C,0xE1,
0x99,0xCC,0xDB,0x36,0x6C,0xED,0x9B,0x76,0x91,0x00,0x04,0x08,0x60,0x08,0x60,0x00,0x38,0x1C,0xFC,0xF1,
0xC7,0x9B,0x33,0xEC,0xCD,0xF1,0xE6,0x91,0x00,0x09,0x38,0x1C,0x00,0x21,0x00,0x21,0x91,0x00,0x05,0x21,
0x00,0x21,0x91,0x00,0x05,0x21,0x38,0x3D,0x00,0x02,0x06,0x02,0x06,0x21,0x00,0x21,0x00,0x02,0x06,0x02,
0x06,0x21,0x00,0x21,0x00,0x02,0x3E,0x1E,0x06,0x00,0x0C,0x00,0x0C,0x02,0x06,0x02,0x06,0x00,0x0C,0x00,
0x0C,0x02,0x06,0x02,0x06,0x00,0x3C,0x1C,0x0C,0x91,0x00,0x05,0x0C,0x00,0x0C,0x91,0x00,0x05,0x0C,0x00,
0x0C,0x00,0x38,0x1C,0x00,0x00,0x80,0x00,0x80,0x91,0x00,0x05,0x80,0x00,0x80,0x91,0x00,0x05,0xB8,0x1C,
0x80,0x01,0x00,0x01,0x00,0x00,0x80,0x00,0x80,0x01,0x00,0x01,0x00,0x00,0x80,0x00,0x80,0x01,0x38,0x1D,
0x00,0x40,0x04,0x40,0x04,0x01,0x00,0x01,0x00,0x40,0x04,0x40,0x04,0x01,0x00,0x01,0x00,0x40,0x3C,0x5C,
0x04,0x91,0x80,0x04,0x40,0x04,0x40,0x04,0x91,0x80,0x04,0x40,0x04,0x40,0x04,0x80,0xB8,0x9C,0x80,0x02,
0x00,0x02,0x00,0x91,0x80,0x04,0x02,0x00,0x02,0x00,0x91,0x80,0x04,0x02,0x38,0x1E,0x00,0x0C,0x00,0x0C,
0x00,0x02,0x00,0x02,0x00,0x0C,0x00,0x0C,0x00,0x02,0x00,0x02,0x00,0x0C,0x38,0x1C,0x91,0x00,0x05,0x0C,
0x00,0x0C,0x91,0x00,0x05,0x0C,0x00,0x0C,0x00,0x00,0x38,0x1C,0x00,0x00,0x10,0x00,0x10,0x91,0x00,0x05,
0x10,0x00,0x10,0x91,0x00,0x05,0x38,0x1C,0xF8,0x04,0x30,0xC7,0xF0,0x00,0x10,0x00,0x10,0x04,0x30,0x04,
0x30,0x00,0x10,0x00,0x10,0x04,0x38,0x1C,0xFC,0x08,0x60,0xCB,0x70,0x04,0x30,0x04,0x30,0x08,0x60,0x08,
0x60,0x04,0x30,0x04,0x30,0x08,0x78,0x1C,0xEC,0xE7,0xC7,0xC3,0x33,0xCD,0xFE,0x3C,0x60,0x91,0x00,0x04,
0x08,0x60,0x08,0x60,0x00,0x38,0x1C,0xCD,0x36,0x6C,0xC3,0xE6,0x6D,0xB3,0x66,0x91,0x00,0x0A,0x38,0x1C,
0xF8,0xF7,0x6C,0xE3,0x36,0x67,0x3F,0x78,0x00,0x21,0x00,0x21,0x91,0x00,0x05,0x21,0x38,0x3D,0xD9,0xB6,
0x6E,0xC3,0x36,0x67,0x30,0x3F,0x00,0x02,0x06,0x02,0x06,0x21,0x00,0x21,0x00,0x02,0x3E,0x1E,0xCF,0xB6,
0x6C,0xDB,0x3E,0x6F,0xB7,0x66,0x06,0x00,0x0C,0x00,0x0C,0x02,0x06,0x02,0x06,0x00,0x3C,0x1C,0xCE,0xF6,
0x67,0xDB,0xE3,0xCD,0x9E,0x3C,0x0C,0x91,0x00,0x05,0x0C,0x00,0x0C,0x00,0x38,0x1C,0x00,0x00,0x80,0x00,
0x80,0x91,0x00,0x05,0x80,0x00,0x80,0x91,0x00,0x05,0xB8,0x1C,0x80,0x01,0x00,0x01,0x00,0x00,0x80,0x00,
0x80,0x01,0x00,0x01,0x00,0x00,0x80,0x00,0x80,0x01,0x38,0x1D,0x00,0x40,0x04,0x40,0x04,0x01,0x00,0x01,
0x00,0x40,0x04,0x40,0x04,0x01,0x00,0x01,0x00,0x40,0x3C,0x5C,0xFC,0x80,0x80,0xC3,0xE0,0x40,0x0D,0xC0,
0x04,0x98,0x91,0x80,0x03,0x40,0x04,0x40,0x04,0x80,0xB8,0x9C,0xCC,0x02,0x00,0xC3,0x30,0x80,0x98,0x80,
0x81,0x82,0x00,0x02,0x00,0x91,0x80,0x04,0x02,0x38,0x1E,0xCC,0xEF,0xC7,0xCF,0x33,0xC7,0xBD,0xBE,0x3B,
0xDD,0xE7,0xCF,0x80,0x02,0x00,0x02,0x00,0x0C,0x38,0x1C,0xCD,0x36,0x6C,0xC3,0x36,0x6C,0xD9,0xBF,0x4D,
0x9B,0x36,0x6C,0xC0,0x0C,0x00,0x0C,0x00,0x00,0x38,0x1C,0xF8,0xF6,0x7C,0xC3,0x37,0xEF,0x19,0xB3,0x3D,
0x9B,0x36,0x6F,0x10,0x91,0x00,0x05,0x38,0x1C,0xD9,0xB6,0x7C,0xC7,0x36,0x03,0xD9,0xB3,0x7D,0x9F,0x36,
0x67,0xF0,0x00,0x10,0x00,0x10,0x04,0x38,0x1C,0xFD,0xB6,0x6C,0xDB,0x36,0x6C,0xD9,0xB7,0x7D,0x9B,0x36,
0x6C,0xC0,0x00,0x00,0x04,0x30,0x00,0x38,0x1C,0xE6,0xF6,0x67,0xDB,0xE3,0xC7,0x8D,0xBB,0x7C,0xD9,0xE6,
0x67,0x80,0x00,0x00,0x08,0x60,0x00,0x38,0x1C,0x00,0x21,0x00,0x21,0x00,0x21,0x91,0x00,0x03,0x21,0x00,
0x21,0x00,0x21,0x91,0x00,0x03,0x21,0x38,0x1C,0x00,0x02,0x06,0x02,0x06,0x02,0x06,0x00,0x00,0x02,0x06,
0x02,0x06,0x02,0x06,0x00,0x00,0x02,0x3E,0x3D,0x00,0x00,0x0C,0x00,0x0C,0x00,0x0C,0x21,0x00,0x00,0x0C,
0x00,0x0C,0x00,0x0C,0x21,0x00,0x00,0x3C,0x1E,0xFE,0x91,0x00,0x04,0x80,0x00,0x02,0x66,0x30,0x36,0x91,
0x00,0x04,0x02,0x06,0x00,0x38,0x1C,0xCC,0x00,0x80,0x00,0x81,0x80,0x80,0x00,0x6F,0x30,0xB6,0x00,0x80,
0x00,0x80,0x00,0x0C,0x00,0xB8,0x1C,0xCC,0xF3,0xCE,0x3D,0xFB,0xCF,0x3E,0x78,0x37,0x67,0x36,0x79,0x00,
0x01,0x91,0x00,0x03,0x01,0x38,0x1C,0xCD,0xDB,0x1F,0x66,0xCD,0xD3,0x66,0xCC,0xB5,0x69,0xB6,0xCC,0x04,
0x40,0x04,0x00,0x80,0x40,0x3C,0x1D,0xF9,0xFB,0x98,0xFE,0xCD,0x8F,0xE6,0xFD,0x35,0xE7,0xB6,0xF0,0x91,
0x80,0x03,0x01,0x00,0x80,0xB8,0x5C,0xC5,0x83,0x18,0x62,0xCD,0x9B,0x66,0xC0,0x3D,0xEF,0xB6,0x3E,0x00,
0x02,0x00,0x40,0x04,0x02,0x38,0x9C,0xC1,0x9F,0x1B,0x6E,0xCD,0x9F,0x66,0xCC,0x98,0xCD,0xB6,0xCC,0x00,
0x0C,0x00,0x80,0x80,0x0C,0x38,0x1E,0xC0,0xF3,0x0E,0x3C,0xCC,0xCF,0x3E,0x7A,0x18,0xC7,0xB6,0x78,0x91,
0x00,0x03,0x02,0x00,0x00,0x38,0x1C,0x00,0x00,0x10,0x00,0x10,0x00,0x56,0x0C,0x00,0x00,0x10,0x00,0x10,
0x00,0x10,0x0C,0x00,0x00,0x38,0x1C,0x00,0x04,0x30,0x04,0x30,0x04,0x3C,0x00,0x00,0x04,0x30,0x04,0x30,
0x04,0x30,0x00,0x00,0x04,0x38,0x1C,0x10,0x08,0x60,0x08,0x60,0x08,0x60,0x00,0x10,0x08,0x60,0x08,0x60,
0x08,0x60,0x00,0x10,0x08,0x78,0x1F,0x91,0xFF,0x12,0xF8,0x1F,0x91,0xFF,0x12,0xF8,0x1F,0x91,0xFF,0x12,
0xF8,0x00,0x00,0x21,0x91,0x00,0x03,0x02,0x06,0x00,0x00,0x21,0x91,0x00,0x03,0x02,0x06,0x00,0x00,0x21,
0x00,0x21,0x00,0x02,0x06,0x91,0x00,0x03,0x0C,0x21,0x00,0x02,0x06,0x91,0x00,0x03,0x0C,0x21,0x00,0x02,
0x06,0x02,0x06,0x00,0x0C,0x21,0x91,0x00,0x03,0x02,0x06,0x00,0x0C,0x21,0x91,0x00,0x03,0x02,0x06,0x00,
0x0C
};

unsigned char menu_data2[] = {
0x91,0x00,0x3C,0x1F,0x91,0xFF,0x12,0xF8,0x1F,0x91,0xFF,0x12,0xF8,0x1F,0x91,0xFF,0x12,0xF8,0x1C,0x91,
0x00,0x12,0x38,0x1C,0x91,0x00,0x12,0x38,0x1C,0xE3,0x80,0x06,0x00,0x00,0x03,0xE1,0xC6,0x6F,0x87,0x1C,
0x70,0x07,0xCF,0x9F,0x3C,0xFB,0xF0,0x38,0x1C,0xE3,0x80,0x06,0x00,0x00,0x03,0x31,0xC6,0x6C,0xCD,0x9C,
0x70,0x06,0x6C,0xD8,0x66,0xC0,0xC0,0x38,0x1C,0xF7,0x9E,0x3E,0x78,0x00,0x03,0x33,0x67,0x6C,0xD8,0xDE,
0xF0,0x06,0x6C,0xD8,0x60,0xC0,0xC0,0x38,0x1C,0xF7,0xB3,0x66,0xCC,0x00,0x03,0x33,0x67,0x6C,0xD8,0xDE,
0xF0,0x06,0x6C,0xDF,0x78,0xF8,0xC0,0x38,0x1C,0xD5,0xB3,0x66,0xFC,0x00,0x03,0xE3,0x66,0xEC,0xD8,0xDA,
0xB0,0x07,0xCF,0x98,0x1E,0xC0,0xC0,0x38,0x1C,0xDD,0xB3,0x66,0xC0,0x00,0x03,0x67,0xF6,0xEC,0xD8,0xDB,
0xB0,0x06,0x0D,0x98,0x06,0xC0,0xC0,0x38,0x1C,0xDD,0xB3,0x66,0xCC,0x00,0x03,0x36,0x36,0x6C,0xCD,0x9B,
0xB0,0x06,0x0C,0xD8,0x66,0xC0,0xC0,0x38,0x1C,0xC9,0x9E,0x3E,0x78,0x00,0x03,0x1E,0x36,0x6F,0x87,0x19,
0x30,0x06,0x0C,0x7F,0x3C,0xF8,0xC0,0x38,0x1C,0x91,0x00,0x12,0x38,0x1C,0x91,0x00,0x12,0x38,0x1C,0x91,
0x00,0x12,0x38,0x1C,0x91,0x00,0x12,0x38,0x1C,0x91,0x00,0x12,0x38,0x1C,0x91,0x00,0x12,0x38,0x1C,0x91,
0x00,0x12,0x38,0x1C,0x91,0x00,0x12,0x38,0x1C,0x91,0x00,0x12,0x38,0x1C,0x91,0x00,0x12,0x38,0x1C,0x91,
0x00,0x12,0x38,0x1C,0x91,0x00,0x12,0x38,0x1C,0x91,0x00,0x12,0x38,0x1C,0x91,0x00,0x12,0x38,0x1C,0xC0,
0x00,0x00,0x19,0xF6,0x91,0x00,0x0D,0x38,0x1C,0xC0,0x00,0x00,0x1B,0x06,0x91,0x00,0x0D,0x38,0x1C,0xC0,
0xF3,0x67,0x9F,0xB6,0x78,0x91,0x00,0x0C,0x38,0x1C,0xC1,0x9B,0x6C,0xDB,0x36,0xCC,0x91,0x00,0x0C,0x38,
0x1C,0xC1,0xFB,0x6F,0xDB,0x36,0xFC,0x91,0x00,0x0C,0x38,0x1C,0xC1,0x83,0x6C,0x1B,0x36,0xC0,0x91,0x00,
0x0C,0x38,0x1C,0xC1,0x99,0xCC,0xDB,0x36,0xCC,0x91,0x00,0x0C,0x38,0x1C,0xFC,0xF1,0xC7,0x9B,0x36,0x78,
0x91,0x00,0x0C,0x38,0x1C,0x91,0x00,0x12,0x38,0x1C,0x91,0x00,0x12,0x38,0x1C,0x91,0x00,0x12,0x38,0x1C,
0xC0,0x00,0x00,0x18,0x00,0x00,0x01,0x80,0x91,0x00,0x0A,0x38,0x1C,0xC0,0x00,0x00,0x18,0x00,0x00,0x01,
0x80,0x91,0x00,0x0A,0x38,0x1C,0xC0,0xF3,0x67,0x9B,0xE6,0x6F,0xF9,0xF1,0xE7,0x80,0x91,0x00,0x08,0x38,
0x1C,0xC1,0x9B,0x6C,0xDB,0x36,0x6C,0xCD,0x9B,0x36,0x91,0x00,0x09,0x38,0x1C,0xC1,0xFB,0x6F,0xDB,0x36,
0x6C,0xCD,0x9B,0xF6,0x91,0x00,0x09,0x38,0x1C,0xC1,0x83,0x6C,0x1B,0x36,0x6C,0xCD,0x9B,0x06,0x91,0x00,
0x09,0x38,0x1C,0xC1,0x99,0xCC,0xDB,0x36,0x6C,0xCD,0x9B,0x36,0x91,0x00,0x09,0x38,0x1C,0xFC,0xF1,0xC7,
0x9B,0x33,0xEC,0xCD,0xF1,0xE6,0x91,0x00,0x09,0x38,0x1C,0x91,0x00,0x12,0x38,0x1C,0x91,0x00,0x12,0x38,
0x1C,0x91,0x00,0x12,0x38,0x1C,0x91,0x00,0x12,0x38,0x1C,0x91,0x00,0x12,0x38,0x1C,0x91,0x00,0x12,0x38,
0x1C,0x91,0x00,0x12,0x38,0x1C,0x91,0x00,0x12,0x38,0x1C,0x91,0x00,0x12,0x38,0x1C,0x91,0x00,0x12,0x38,
0x1C,0x91,0x00,0x12,0x38,0x1C,0x91,0x00,0x12,0x38,0x1C,0xF8,0x00,0x00,0xC3,0xE0,0x91,0x00,0x0D,0x38,
0x1C,0xCC,0x00,0x00,0xC3,0x30,0x91,0x00,0x0D,0x38,0x1C,0xCC,0xE7,0xC7,0xC3,0x33,0xCD,0x9E,0x3C,0x91,
0x00,0x0A,0x38,0x1C,0xCD,0x36,0x6C,0xC3,0xE6,0x6D,0xB3,0x66,0x91,0x00,0x0A,0x38,0x1C,0xF8,0xF6,0x6C,
0xC3,0x36,0x67,0x3F,0x78,0x91,0x00,0x0A,0x38,0x1C,0xD9,0xB6,0x6C,0xC3,0x36,0x67,0x30,0x1E,0x91,0x00,
0x0A,0x38,0x1C,0xCD,0xB6,0x6C,0xDB,0x36,0x6D,0xB3,0x66,0x91,0x00,0x0A,0x38,0x1C,0xC6,0xF6,0x67,0xDB,
0xE3,0xCD,0x9E,0x3C,0x91,0x00,0x0A,0x38,0x1C,0x91,0x00,0x12,0x38,0x1C,0x91,0x00,0x12,0x38,0x1C,0x91,
0x00,0x12,0x38,0x1C,0xF8,0x00,0x00,0xC3,0xE0,0x00,0x09,0x80,0x00,0x98,0x91,0x00,0x08,0x38,0x1C,0xCC,
0x00,0x00,0xC3,0x30,0x00,0x18,0x00,0x01,0x80,0x91,0x00,0x08,0x38,0x1C,0xCC,0xE7,0xC7,0xC3,0x33,0xC7,
0xBD,0xBE,0x3B,0xD9,0xE7,0xC7,0x80,0x91,0x00,0x05,0x38,0x1C,0xCD,0x36,0x6C,0xC3,0x36,0x6C,0xD9,0xB3,
0x4D,0x9B,0x36,0x6C,0xC0,0x91,0x00,0x05,0x38,0x1C,0xF8,0xF6,0x6C,0xC3,0x37,0xEF,0x19,0xB3,0x3D,0x9B,
0x36,0x6F,0x91,0x00,0x06,0x38,0x1C,0xD9,0xB6,0x6C,0xC3,0x36,0x03,0xD9,0xB3,0x6D,0x9B,0x36,0x63,0xC0,
0x91,0x00,0x05,0x38,0x1C,0xCD,0xB6,0x6C,0xDB,0x36,0x6C,0xD9,0xB3,0x6D,0x9B,0x36,0x6C,0xC0,0x91,0x00,
0x05,0x38,0x1C,0xC6,0xF6,0x67,0xDB,0xE3,0xC7,0x8D,0xB3,0x3C,0xD9,0xE6,0x67,0x80,0x91,0x00,0x05,0x38,
0x1C,0x91,0x00,0x12,0x38,0x1C,0x91,0x00,0x12,0x38,0x1C,0x91,0x00,0x12,0x38,0x1C,0xF8,0x91,0x00,0x04,
0x80,0x00,0x00,0x62,0x30,0x36,0x91,0x00,0x07,0x38,0x1C,0xCC,0x91,0x00,0x03,0x01,0x80,0x00,0x00,0x67,
0x30,0x36,0x91,0x00,0x07,0x38,0x1C,0xCC,0xF3,0xCE,0x3C,0xFB,0xCE,0x3E,0x78,0x37,0x67,0x36,0x78,0x91,
0x00,0x06,0x38,0x1C,0xCD,0x9B,0x1B,0x66,0xCD,0x93,0x66,0xCC,0x35,0x69,0xB6,0xCC,0x91,0x00,0x06,0x38,
0x1C,0xF9,0xFB,0x18,0x7E,0xCD,0x8F,0x66,0xFC,0x35,0x67,0xB6,0xF0,0x91,0x00,0x06,0x38,0x1C,0xC1,0x83,
0x18,0x60,0xCD,0x9B,0x66,0xC0,0x3D,0xED,0xB6,0x3C,0x91,0x00,0x06,0x38,0x1C,0xC1,0x9B,0x1B,0x66,0xCD,
0x9B,0x66,0xCC,0x18,0xCD,0xB6,0xCC,0x91,0x00,0x06,0x38,0x1C,0xC0,0xF3,0x0E,0x3C,0xCC,0xCF,0x3E,0x78,
0x18,0xC7,0xB6,0x78,0x91,0x00,0x06,0x38,0x1C,0x91,0x00,0x06,0x46,0x91,0x00,0x0B,0x38,0x1C,0x91,0x00,
0x06,0x3C,0x91,0x00,0x0B,0x38,0x1C,0x91,0x00,0x12,0x38,0x1F,0x91,0xFF,0x12,0xF8,0x1F,0x91,0xFF,0x12,
0xF8,0x1F,0x91,0xFF,0x12,0xF8,0x91,0x00,0x3C
};

extern unsigned short*   plane1;  // startadress of plane 1
extern unsigned short*   plane2;  // startadress of plane 2

extern short boxes_rand; // number of random boxes
extern short dest_rand;  // number of random destination squares
extern short solid_rand; // percentage of solid blocks within level
extern short level_nr;   // LEVEL number
extern short file_nr;    // FILE number (mXX)
extern short play_mode;  // mode of play

short GetInputKeyWithAPD(void);
short isYesKey(short key);
short isNoKey(short key);


short y0array[] = { 28,40,60,71,81 };
short y1array[] = { 38,50,70,81,92 };


/*===========================================================================*/
/* retrieves value parameter specified by given index                        */
/*===========================================================================*/
short GetNumber(short index) {
    switch(index) {
        case 0: return file_nr;
        case 1: return level_nr;
        case 2: return boxes_rand;
        case 3: return dest_rand;
        case 4: return solid_rand;
    }
    return 33;
}


/*===========================================================================*/
/* sets parameter specified by given index                                   */
/*===========================================================================*/
void SetNumber(short index,short nr) {
    if (nr < 0 || nr > 999) return;

    switch(index) {
        case 0: if (nr<100) file_nr    = nr; break;
        case 1:             level_nr   = nr; break;
        case 2:             boxes_rand = nr; break;
        case 3:             dest_rand  = nr; break;
        case 4: if (nr<101) solid_rand = nr; break;
    }
}


/*===========================================================================*/
/* draws number or file name specified by given index                        */
/*===========================================================================*/
void DrawNumber(short index,short mode) {
    char     buf[10];
    SCR_RECT rect;
    short    nr  = GetNumber(index);

    rect.xy.x0 = 112 + C89_92(0,40);
    rect.xy.x1 = 152 + C89_92(0,40);
    rect.xy.y0 = y0array[index] + C89_92(0,14);
    rect.xy.y1 = y1array[index] + C89_92(0,14);

    if (index) sprintf(buf,"%03d",nr);
    else       sprintf(buf,"m%02d",nr);

    SetPlane(0);
    ScrRectFill(&rect, ScrRect, mode);
    DrawStr(rect.xy.x0+11,rect.xy.y0+2,buf,A_XOR);
    SetPlane(1);
    ScrRectFill(&rect, ScrRect, mode);
    DrawStr(rect.xy.x0+11,rect.xy.y0+2,buf,A_XOR);
}


/*===========================================================================*/
/* inverts an menu entry specified by the given index                        */
/*===========================================================================*/
void XORModeString(short idx) {
    SCR_RECT rect;

    if (idx) {
        rect.xy.x0 = 105 + C89_92(0,40);
        rect.xy.y0 = 7   + C89_92(0,15);
        rect.xy.x1 = 150 + C89_92(0,40);
        rect.xy.y1 = 16  + C89_92(0,15);
    }
    else {
        rect.xy.x0 = 50  + C89_92(0,40);
        rect.xy.y0 = 7   + C89_92(0,15);
        rect.xy.x1 = 103 + C89_92(0,40);
        rect.xy.y1 = 16  + C89_92(0,15);
    }

    SetPlane(0);
    ScrRectFill(&rect, ScrRect, A_XOR);
    SetPlane(1);
    ScrRectFill(&rect, ScrRect, A_XOR);
}


/*===========================================================================*/
/* Handles the main menu                                                     */
/*===========================================================================*/
short HandleMainMenu(void) {
    short i,yes,no,read;
    short line = 0;

    FontSetSys(F_6x8);

    SetPlane(1);
    ClearScreen();
    SetPlane(0);
    ClearScreen();

    Decompress(((unsigned char*)plane1)+C89_92(0,455),menu_data1,160*100/8,20,10);
    Decompress(((unsigned char*)plane2)+C89_92(0,455),menu_data2,160*100/8,20,10);

    XORModeString(play_mode);

    for (i=0;i<5;i++) DrawNumber(i,A_REVERSE);

    do {
        read = GetInputKeyWithAPD();
        yes  = isYesKey(read);
        no   = isNoKey(read);
        if (read == KEY_UP) {
            if (line) DrawNumber(line-1,A_REVERSE);
            line--;
            if (line < 0) line = 5;
            if (line) DrawNumber(line-1,A_NORMAL);
        }
        else if (read == KEY_DOWN) {
            if (line) DrawNumber(line-1,A_REVERSE);
            line++;
            if (line > 5) {
                line = 0;
            }
            else {
                DrawNumber(line-1,A_NORMAL);
            }
        }
        else if (read == KEY_LEFT) {
            if (line) {
                SetNumber(line-1,GetNumber(line-1)-1);
                DrawNumber(line-1,A_NORMAL);
            }
            else {
                XORModeString(0);
                XORModeString(1);
                play_mode = !play_mode;
            }
        }
        else if (read == KEY_RIGHT) {
            if (line) {
                SetNumber(line-1,GetNumber(line-1)+1);
                DrawNumber(line-1,A_NORMAL);
            }
            else {
                XORModeString(0);
                XORModeString(1);
                play_mode = !play_mode;
            }
        }
    }
    while (!yes && !no);

    return yes;
}
